
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>【Go语言】【15】GO语言的面向对象 / iVAN</title>

    <meta name="description" content="【Go语言】【15】GO语言的面向对象 原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://qingkechina.blog.51cto.com/5552198/1675872 GO是不是面向对象的语言? GO作者如是说:&quot;是,也不是.&quot; 正如前面所说:GO是一种面向类型的语言,它有类型和方法,但没有类的概念,程序员可以用一种面向对象的风格(或者说是方式)来编程,下面我们从封装性.继承性和多态性三大面向对象的特性谈谈GO语言 1.封装性        ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">【Go语言】【15】GO语言的面向对象</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原创作品，允许转载，转载时请务必以超链接形式标明文章 <a href="http://qingkechina.blog.51cto.com/5552198/1675872" rel="external nofollow noreferrer">原始出处</a> 、作者信息和本声明。否则将追究法律责任。<a href="http://qingkechina.blog.51cto.com/5552198/1675872" rel="external nofollow noreferrer">http://qingkechina.blog.51cto.com/5552198/1675872</a></p>
<p>GO是不是面向对象的语言？</p>
<p>GO作者如是说：“是，也不是。”</p>
<p>正如前面所说：GO是一种面向类型的语言，它有类型和方法，但没有类的概念，程序员可以用一种面向对象的风格（或者说是方式）来编程，下面我们从封装性、继承性和多态性三大面向对象的特性谈谈GO语言</p>
<p>1、封装性</p>
<p>       面向对象的语言中，“类”是基本单位，它把属性、方法局限在“类”中，并对外提供公共方法让使用者操作对象。当然这一过程离不开修饰符：public、protected、private等。</p>
<p>       GO语言如何实现封装性呢?它是通过结构体（struct）和为类型添加方法的方式实现的。</p>
<p>       例如，封装一个矩形（Rect）类，试想调用者会对矩形类做什么操作呢？无非就是看看它的面积、周长之类的信息，那么按照面向对象的编程思想来说，只要向使用者暴露getArea()、getPerimeter()方法即可，使用者无须接触到矩形的长和宽。</p>
<table>
<tbody>
<tr>
<td>
<br />/**</p>
<p>  * 定义一个结构体，里面有两个成员length和width</p>
<p>  */</p>
<p>type Rect struct {</p>
<p>        length, width int</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<p>接下来为结构体定义两个方法getArea()和getPerimeter()，分别用来读取矩形的面积和周长</p>
<table>
<tbody>
<tr>
<td>
<br />/**</p>
<p>  * 获取矩形的面积</p>
<p>  */</p>
<p>func (r *Rect) GetArea() int {</p>
<p>        return r.length * r.width</p>
<p>}</p>
<p>/**</p>
<p>  * 获取矩形的周长</p>
<p>  */</p>
<p>func (r *Rect) GetPerimeter() int {</p>
<p>        return (r.length + r.width) * 2</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<p>为了让该包之外的函数调用到GetArea()和GetPerimeter()，所以这里函数的首字母大写。同时为了结构体初始化更面向对象些，再定义一个用于初始化结构体的方法NewRect()</p>
<table>
<tbody>
<tr>
<td>
<br />/**</p>
<p>  * 初始化结构体Rect</p>
<p>  */</p>
<p>func NewRect(length, width int) *Rect {</p>
<p>        return &amp;Rect{length, width}</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<p>经过这样的封装，使用者可以以面向对象的方式调用Rect了 ：）</p>
<table>
<tbody>
<tr>
<td>
<br />/**</p>
<p>  * 使用者先引入Rect.go的路径</p>
<p>  */</p>
<p>import (</p>
<p>        "cube"</p>
<p>        "fmt"</p>
<p>)</p>
<p>/**</p>
<p> * 通过cube调用NewRect()生成*Rect对象</p>
<p> */</p>
<p>func main() {</p>
<p>        r := cube.NewRect(10, 20)</p>
<p>        fmt.Println("面积：", r.GetArea(), "  周长：", r.GetPerimeter())</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<hr>
<br />【备注】：</p>
<p>Rect.go和测试main.go路径结构如下</p>
<p><a href="http://s3.51cto.com/wyfs02/M01/6F/CE/wKioL1WpHPnTstkAAAAnAJYeePs897.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNkYvQ0Uvd0tpb0wxV3BIUG5Uc3RrQUFBQW5BSlllZVBzODk3LmpwZw==.jpg"></a></p>
<p>其中Rect.go所属包为cube、main.go所属包为main</p>
<hr>
<br />执行程序，运行结果如下：</p>
<p><a href="http://s3.51cto.com/wyfs02/M02/6F/CE/wKioL1WpHarwUCv-AABTfzOr2QE794.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNkYvQ0Uvd0tpb0wxV3BIYXJ3VUN2LUFBQlRmek9yMlFFNzk0LmpwZw==.jpg"></a></p>
<p>2、继承性</p>
<p><a href="http://s3.51cto.com/wyfs02/M01/6F/CF/wKioL1Wpt9uz-QZHAABs_WAb8pQ174.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNkYvQ0Yvd0tpb0wxV3B0OXV6LVFaSEFBQnNfV0FiOHBRMTc0LmpwZw==.jpg"></a></p>
<p>       rect结构体定义两个方法，分别用于获取面积和周长，cube结构体也定义了两个方法，一个是获取体积，另一个重写父结构体rect的获取周长：</p>
<p>（1）在cube目录下创建rect.go文件，里面写rect代码</p>
<table>
<tbody>
<tr>
<td>
<br />// 让rect结构体在cube包内</p>
<p>package cube</p>
<p>// 定义rect结构体</p>
<p>type rect struct{</p>
<p>        length, width int</p>
<p>}</p>
<p>/**</p>
<p> * 获取矩形的面积</p>
<p> */</p>
<p>func (r Rect) GetArea() int {</p>
<p>        return r.length * r.width</p>
<p>}</p>
<p>/**</p>
<p> * 获取矩形的周长</p>
<p> */</p>
<p>func (r Rect) GetPerimeter() int {</p>
<p>        return (r.length + r.width) * 2</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<p>（2）在cube目录下创建cube.go文件，里面写cube代码</p>
<table>
<tbody>
<tr>
<td>
<br />// 让Cube结构体在cube包内</p>
<p>package cube</p>
<p>// 由于Cube结构体需要对外，所以首字母大写</p>
<p>type Cube struct {</p>
<p>        Rect           // 这里通过嵌套结构体实现GO的继承</p>
<p>        height int</p>
<p>}</p>
<p>/**</p>
<p> * 获取立方体的体积</p>
<p> */</p>
<p>func (c Cube) GetVolume() int {</p>
<p>        return c.Rect.length * c.Rect.width * c.height</p>
<p>}</p>
<p>/**</p>
<p> * 重写父类获取周长方法</p>
<p> */</p>
<p>func (c Cube) GetPerimeter() int {</p>
<p>        return (c.Rect.length + c.Rect.width + c.height) * 4</p>
<p>}</p>
<p>/**</p>
<p> * 为了更象面向对象编程些，这里定义了一个方法获取Cube对象</p>
<p> */</p>
<p>func NewCube(length, width, height int) Cube {</p>
<p>        return Cube{Rect: Rect{length, width}, height: height}</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<p>（3）在src目录下创建main.go文件，该文件与cube目录同级，里面写测试代码</p>
<table>
<tbody>
<tr>
<td>
<br />// 让main()方法的包为main</p>
<p>package main</p>
<p>import (</p>
<p>       "cube"  // 由于要用到上面定义的Cube结构体，所以需要引入Cube结构体所属包</p>
<p>       "fmt"</p>
<p>)</p>
<p>func main() {</p>
<p>        var c cube.Cube = cube.NewCube(10, 20, 30)  // 通过包名调用cube.go定义的对外方法NewCube()</p>
<p>        fmt.Println("面积：", c.GetArea(), "，体积：", c.GetVolume())  // 通过变量c调用相应方法</p>
<p>        fmt.Println("周长:", c.GetPerimeter())</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<p>执行go run main.go，得到执行结果：</p>
<p><a href="http://s3.51cto.com/wyfs02/M00/6F/D1/wKiom1WpuiywwgvAAABG6TF_56Q376.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNkYvRDEvd0tpb20xV3B1aXl3d2d2QUFBQkc2VEZfNTZRMzc2LmpwZw==.jpg"></a></p>
<p>       从运行结果可以看到，尽管Cube没有定义GetArea()方法，但通过c.GetArea()的确调用到了同时并打印出结果；由于Cube重写了GetPerimeter()方法，从结果来看c.GetPerimeter()执行的是Cube的GetPerimeter()就去。</p>
<p>       从该例也不难看出GO的继承性是通过结构的嵌套来实现的</p>
<p>3、多态性</p>
<p>多态意味着一个对象有多重特征，在特定的情况下表现不同的状态，即对应着不同的方法</p>
<p><a href="http://s3.51cto.com/wyfs02/M01/6F/D4/wKiom1Wp5cjDZPmhAACjxTnjA4U819.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNkYvRDQvd0tpb20xV3A1Y2pEWlBtaEFBQ2p4VG5qQTRVODE5LmpwZw==.jpg"></a></p>
<p>Mp3和Iphone都实现了USB接口，并分别实现接口USB定义的方法，当面向对象如此调用时：</p>
<p>USB u1 = new Mp3();</p>
<p>u1.connect();    // 打印出“mp3”</p>
<p>USB u2 = new Iphone();</p>
<p>u2.connect();    // 打印出“iphone”</p>
<p>同样的接口（USB）对象（u1, u2），由于实现类不同，调用相同的方法（connect()），最终的效果是不同的，这就是多态的作用，一般用于“控制反转”。</p>
<p>那么Go呢？</p>
<p>Go可以通过Interface、struct模拟实现多态</p>
<p>在src下创建usb目录，在usb目录下创建usb.go文件，里面定义USB接口</p>
<table>
<tbody>
<tr>
<td>
<br />// 把接口USB放在usb包中</p>
<p>package usb</p>
<p>// 定义USB接口，里面只有一个Connect()方法</p>
<p>type USB interface {</p>
<p>        Connect()</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<p>在usb目录下创建mp3.go文件，里面定义Mp3结构体，并为该结构体增加Connect()，这样就相当于实现了接口USB</p>
<table>
<tbody>
<tr>
<td>
<br />// 把Mp3结构体放在usb包中</p>
<p>package usb</p>
<p>import (</p>
<p>        "fmt"</p>
<p>)</p>
<p>// 定义Mp3空结构体</p>
<p>type Mp3 struct {</p>
<p>}</p>
<p>// 为Mp3增加Connect()方法，这样就缺省实现了USB接口</p>
<p>func (m Mp3) Connect() {</p>
<p>        fmt.Println("mp3")</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<p>同样，在usb目录下创建iphone.go文件，里面定义Iphone结构体</p>
<table>
<tbody>
<tr>
<td>
<br />// 把Iphone结构体放在usb包中</p>
<p>package usb</p>
<p>import (</p>
<p>      "fmt"</p>
<p>)</p>
<p>// 定义Iphone空结构体</p>
<p>type Iphone struct {</p>
<p>}</p>
<p>// 为Iphone增加Connect()方法，这样就缺省实现了USB接口</p>
<p>func (i Iphone) Connect() {</p>
<p>        fmt.Println("iphone")</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<p>下面演示GO语言的多态性：</p>
<p>在src目录下创建main.go文件，该文件与usb目录同级，里面写测试代码</p>
<table>
<tbody>
<tr>
<td>
<br />package main</p>
<p>import (</p>
<p>        "usb"</p>
<p>)</p>
<p>func main() {</p>
<p>        var m usb.USB = usb.Mp3{}</p>
<p>        m.Connect()</p>
<p>        var n usb.USB = usb.Iphone{}</p>
<p>        n.Connect()</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<p>执行程序，运行结果如下：</p>
<p><a href="http://s3.51cto.com/wyfs02/M02/6F/D4/wKiom1Wp622zkvO8AAA9r_LrKnA061.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNkYvRDQvd0tpb20xV3A2MjJ6a3ZPOEFBQTlyX0xyS25BMDYxLmpwZw==.jpg"></a></p>
<hr>
<br />【备注】：</p>
<p>关于本文的演示代码可以在本章节源代码处下载</p>
<hr>
<p>本文出自 “<a href="http://qingkechina.blog.51cto.com/" rel="external nofollow noreferrer">青客</a>” 博客，请务必保留此出处<a href="http://qingkechina.blog.51cto.com/5552198/1675872" rel="external nofollow noreferrer">http://qingkechina.blog.51cto.com/5552198/1675872</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 21:06:36</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e9%9d%a2%e5%90%91%e5%af%b9%e8%b1%a1/" title="面向对象">面向对象</a>, <a href="https://www.iamivan.net/tag/%e5%b0%81%e8%a3%85/" title="封装">封装</a>, <a href="https://www.iamivan.net/tag/%e7%bb%a7%e6%89%bf/" title="继承">继承</a>, <a href="https://www.iamivan.net/tag/%e5%a4%9a%e6%80%81/" title="多态">多态</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>【Go语言】【15】GO语言的面向对象的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze4PBAp.html" rel="bookmark">C&num;语言与Java语言程序的比较</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				迈入二十一世纪以来,信息行业飞速壮大,其中在软件开发中Java语言与C#语言都独当一面,得到了逐步完善和广泛的应用,Java语言和C#语言都是一种面向对象的语言,但Java程序和C#程序还是有一定的区别. 下面分别是两种语言的程序的例子. 1.Java语言的基本程序: Import java.util.*; Package HelloJava{ Public class Message{ Public static void main(String [] args){ System.out.pr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkwW2Op.html" rel="bookmark">Swift语言指南&lpar;三&rpar;--语言基础之整数和浮点数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:Swift语言指南(三)--语言基础之整数和浮点数   整数   整数指没有小数的整数,如42,-23.整数可以是有符号的(正数,零,负数),也可以是无符号的(正数,零). Swift提供了8,16,32,64位形式的有符号和无符号的整数,这些整数遵循与C语言相似的命名规则.如8位无符号整数的类型为UInt8,32位有符号整数的类型为Int32,和Swift语言的其它类型一样,这些整型命名以大写字母开头.   整数的边界 你可以通过min或max属性为每一个整数类型指定一个最小值或最大值:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zenaAxb.html" rel="bookmark">《OOD启思录》&mdash;第1章1&period;5节造原型：相同语言与不同语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.5 构造原型:相同语言与不同语言OOD启思录原型领域可划分为两大流派.一派认为原型与最终产品应当用同一种语言编写(same-language prototyping),另一派认为原型与最终产品应当用不同的语言编写(different-language prototyping).相同语言原型带来的好处看起来简直无法拒绝:使用同一种语言,这意味着同一套工具,相同的参考书,相同的学习曲线,相同的培训课程.一点也不奇怪,这两大流派中相同语言原型被更多地运用. 最后的原型终将成为产品.这一模型的主要缺			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGQ2PvM.html" rel="bookmark">Java语言与C&plus;&plus;语言的差异总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java的设计者曾说过,设计这门语言的灵感主要来自于C++. 世上先有C++,然后才有Java,整个Java语言的发展历史就是一部对C++的填坑史.所以在Java语言学习过程中,将其与C++语言对比是一件有意义的事情.通过这些对比,我们能够了解到Java语言相对于C++语言有哪些改进,能带给我们哪些进步,这样对于更加深入理解这两种语言是大有裨益的. 下面我总结一下Java语言与C++语言的各种差异. 1.Java用来操纵对象的引用可以先初始化再指向对象,而C++的引用必须在初始化时就指向对象.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3oO4gb.html" rel="bookmark">Thinkphp搭建包括JS多语言的多语言项目实现方法&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Thinkphp搭建包括JS多语言的多语言项目实现方法.分享给大家供大家参考.具体实现方法如下: 一.问题: 项目需要开发英文版,于是需要搭建多语言项目. 项目使用Thinkphp框架,隐约记得Thinkphp有多语言设置,翻看了帮助手册,果然有,这就边实验边开始: 二.实现方法: Thinkphp采用app_begain来检测和切换语言包,语言包和项目相关,构架等都比较简单,具体的这里:http://www.thinkphp.cn/info/188.html 搭建好了,就可以使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mxo6OOb.html" rel="bookmark">r语言-对一个向量的划分，求C语言或R语言实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 对一个向量的划分,求C语言或R语言实现 1C 向量U={123456}利用R1属性划分为:U/R1={{123}{456}}利用R2属性划分为:U/R2={{12}{3456}}利用R3属性划分为:U/R3={{1234}{56}}最后得到划分的交集:U/R={{12}{3}{4}{56}}			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boR8ADz.html" rel="bookmark">Swift语言指南&lpar;一&rpar;--语言基础之常量和变量</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:Swift语言指南(一)--语言基础之常量和变量 Swift 是开发 iOS 及 OS X 应用的一门新编程语言,然而,它的开发体验与 C 或 Objective-C 有很多相似之处. Swift 提供了 C 与 Objective-C 中的所有基础类型,包括表示整数的 Int,表示浮点数的 Double 与 Float,表示布尔值的 Bool,以及表示纯文本数据的 String. Swift 还为两个基本集合类型 Array 与 Dictionary 提供了强大的支持,详情可参考 (集合			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b320eAz.html" rel="bookmark">各国语言缩写列表&comma;各国语言缩写-各国语言简称&comma;世界各国域名缩写</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				$amount = '12345.67'; $formatter = new \NumberFormatter('en_GB', \NumberFormatter::CURRENCY); echo 'UK: ' . $formatter-&gt;formatCurrency($amount, 'EUR') . '&lt;br/&gt;'; $formatter = new \NumberFormatter('de_DE', \NumberFormatter::CURRENCY); echo 'DE: '			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQBNaZM.html" rel="bookmark">c语言与c&plus;&plus;语言之间的相互转化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 c语言与c++语言之间的相互转化 struct student*p0 scanf(&quot;%s&quot;,p0-&gt;num) scanf(&quot;%s&quot;,&amp;p0-&gt;name) 解决方案 C++也能兼容C,直接编译看有没有什么语法错误 解决方案二: 对的,C++编译器本来就支持几乎所有C语法 你为何还需要改 C --&gt; C++ #include scanf(&quot;%s&quot;,p0-&gt;num); --&gt; std::cin &gt;&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGEE0oM.html" rel="bookmark">c语言-C语言递归函数C语言递归函数C语言递归函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 C语言递归函数C语言递归函数C语言递归函数 #include&lt;stdio.h&gt; #include&lt;stdlib.h&gt; //用递归函数来计算N的阶乘 double factorial(int n) { double result; if(n&lt;0) { printf(&quot;输入错误 &quot;); } else if(n==1 ||n==0) { result=1; } else { result=factorial(n-1)*n; //n=5 5-1=4 4*			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJwwqb.html" rel="bookmark" class="title">js闭包的用途</a>
					<div>
						我们来看看闭包的用途.事实上,通过使用闭包,我们可以做很多事情.比如模拟面向对象的代码风格:更优雅,更简洁的表达出代码:在某些方面提升代码的执行效率. 1 匿名自执行函数 我们知道所有的变量,如果不加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zemkNz.html" rel="bookmark" class="title">XML里的非法字符</a>
					<div>
						xml There are 5 predefined entity references in XML: &lt; &lt; less than &gt; &gt; greater than &amp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVRoQz.html" rel="bookmark" class="title">全国大学FTP站列表</a>
					<div>
						为了方便广大网友从ftp站点查找资料,我们特意向您介绍这份国内大学ftp服务器站点列表,希望对你有用. 成都信息工程学院 ftp://xsc.cuit.edu.cn/ 大连理工大学 ftp://ftp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAJJ2p.html" rel="bookmark" class="title">有吸引力的大字号typography在网页设计中的运用</a>
					<div>
						我们都知道typography多么重要.搭配合适的字体.颜色和特殊效果能极大地帮助你向网页的浏览者传递信息.下面展示的这些网站大多在Header中运用了大字号的typography,也有的在子标题或者 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9MxeYPp.html" rel="bookmark" class="title">SEO的挑战不在于排名 在于变化</a>
					<div>
						一个新站上线之后我们需要做的推广有很多,随着时间累积,效果出来之后,我们的SEO之路算不算告一段落呢? 答案显然是否定的.SEO的挑战不在于排名,而在于变化.随着网民的变化,互联网也在变化,搜索引擎更 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7KQAz.html" rel="bookmark" class="title">浅析新浪博客的优化方法</a>
					<div>
						怎么优化博客,是一个很历史悠久的seo问题,不过通过下面的案例就能真正懂的如何做博客优化.很多人都在说博客已经很泛滥了,有哪个seo站长没十几二十个博客,数量固然重要,不收录百度都没有你的博客,再多也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPoE1M.html" rel="bookmark" class="title">实例分析如何做好首页关键词排名</a>
					<div>
						相信很多站长朋友对网站权重都很关心,那么影响一个网站的权重有哪些因素呢?很多人会说网站权重不就是外链和内容吗,没错,就是这样,但是这简简单单的&quot;内容外链&quot;四个字里面却有许多学问.首 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKw1vp.html" rel="bookmark" class="title">UVa 1422：Processor 任务处理问题</a>
					<div>
						题目大意:有n个任务送到处理器处理,每个任务信息包括r,d,w,r代表开始时间,w代表必须要结束的时间,w指需要多少时间处理. 其中处理器的处理速度可以变速,问处理器最小需要多大速度才能完成工作? 输 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKK7Vp.html" rel="bookmark" class="title">Servlet开发入门（5） 取得初始化配置信息</a>
					<div>
						在Servlet开发中要取得初始化参数用到了JSP内置对象中的config对象,此对象实际上就是ServletConfig对象的接口实例.这一篇文章讲解 Servlet初始化的参数的取得.就是在Ser ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKDlmM.html" rel="bookmark" class="title">PS制作质感玻璃字</a>
					<div>
						PS制作质感玻璃字的最终效果图 1.打开Photoshop,新建一个文件.模式为RGB,分辨率要大一些,我把它定为150像素/英寸,白色背景.至于文件大小,要看你的需要了. 将前/背景色板复位,选择文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjLDEp.html" rel="bookmark" class="title">Win7预装家庭普通版 如何升级至SP1</a>
					<div>
						上回我们看到Jacky教小陈在Win7预装家庭普通版的笔记本中开启了Aero特效,让Win7家庭普通版也具备了绚丽透明的显示效果.在正版操作系统的使用上,小陈也渐渐倾向于Jacky的看法了.这次问题又 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AyN6p.html" rel="bookmark" class="title">王通：淘宝分销策划市场需求巨大</a>
					<div>
						 目前,越来越多的传统企业开始从开淘宝店开始试水来做电子商务,促使淘宝店数量急剧上升,刚刚查询了一下,淘宝店铺已经超过365万个.用于店铺越来越多,竞争自然越来越激烈,一个企业如何才能通过淘宝把自己的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZZm2z.html" rel="bookmark" class="title">EXCEL怎么制作大事记图表？</a>
					<div>
						  在宣传方面,经常会看到一些记录历史事件.成长历程的图,非常的直观.好看(如下图所示).那么是怎么做到呢呢?这里我们介绍一下用EXCEL表格快速做出事件记录图的方法. 1.首先,做出基础表格(如下图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkdJOb.html" rel="bookmark" class="title">怎样透明Java窗体</a>
					<div>
						步骤(STEPS) 打开Java开发工具Eclipse软件,依次选择&quot;文件&quot;.&quot;新建&quot;.&quot;项目&quot;,在&quot;新建项目&quot;窗口中选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3o1jp.html" rel="bookmark" class="title">Windows Blue取消&OpenCurlyDoubleQuote;使用指定的镜像文件恢复Windows系统&rdquo;的选项？</a>
					<div>
						版本号为9436的Windows Blue被曝光之后引发全球用户的疯狂,纷纷开始挖掘新系统所带来的改变.随后细心的网友发现Blue在开机启动项中已经移除了&quot;系统镜像恢复&quot;功能,从  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7Ww0M.html" rel="bookmark" class="title">Win7怎么启用与配置语音识别功能</a>
					<div>
						  启用语音识别 第一步:首先进入&quot;控制面板&quot;,把查看方式设置为&quot;小图标&quot;,然后进入&quot;语音识别&quot;选项,这里列举着语音控制方面的所有项目.我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwZnBb.html" rel="bookmark" class="title">Mac版QQ截图用不了怎么办？</a>
					<div>
						  在 Mac 上使用 QQ 的小伙伴,可能或多或少都会遇到突然出现不能截图的问题.这是软件的原因导致,这里简单介绍下怎么解决在 Mac 上的 QQ 不能截图的解决方法. 1.首先我们打开 Mac 上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwAvKp.html" rel="bookmark" class="title">手机停机收不到验证短信怎么网上交话费</a>
					<div>
						  这里以农行网上银行为例.将银行k宝插入电脑,弹出农行登录界面,点击&quot;个人网上银行登录&quot;. 点击&quot;k宝登录&quot;. 输入k宝密码.点击&quot;确定&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3rKPz.html" rel="bookmark" class="title">巧用replace将文字表情替换为图片&lowbar;javascript技巧</a>
					<div>
						微博或者论坛上常见的效果,选择表情插入文本域的时候,显示的是类似[哈哈]这样的字符串,下面是把表情字符串转换为图片表情的一种方法 复制代码 代码如下: &lt;div id=&quot;test&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrdnAM.html" rel="bookmark" class="title">网站数据分析：分析的前提&mdash;数据质量3</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 前面的两篇文章--分析的前提-数据质量1和分析的前提-数据质量2分别介绍了通过Data Profiling的方法获取数据的统计信息,并使用Data Au ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAX62M.html" rel="bookmark" class="title">WebComponent魔法堂&colon;深究Custom Element 之 面向痛点编程</a>
					<div>
						前言  最近加入到新项目组负责前端技术预研和选型,一直偏向于以Polymer为代表的WebComponent技术线,于是查阅各类资料想说服老大向这方面靠,最后得到的结果是:&quot;资料99%是英语 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYDGOp.html" rel="bookmark" class="title">两年漫长重组路：汇通闭门不见人卖壳没时间表</a>
					<div>
						并不是&quot;卖壳&quot;方案本身行不通,如果能寻觅到优质的资产置入,重组则指日可待 南方汇通(000920.SZ)待&quot;壳&quot;而沽不是一两天. 这不是炒冷饭,但是显然也已经不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40V71z.html" rel="bookmark" class="title">Ccentos6 编译hadoop2&period;6 b报错</a>
					<div>
						问题描述 Ccentos6 编译hadoop2.6 b报错 http://my.csdn.net/my/mycsdnFailed to execute goal org.apache.maven.pl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNjG4NM.html" rel="bookmark" class="title">Java Web应用程序实现基础的文件下载功能的实例讲解&lowbar;java</a>
					<div>
						基础思路:之前的思路一直是弹出一个框问用户想要存放文件的位置,然后我再生成个文件放到那.然而我这个想法并没有成功. 点击链接来下载文件的方式很简便,后台把文件流输出来,通过浏览器实现下载功能,包括询问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Zjk7z.html" rel="bookmark" class="title">java-一个关于json-lib转json的小问题</a>
					<div>
						问题描述 一个关于json-lib转json的小问题 最近在使用json-lib把xml转成json的时候,发现生产的json的属性前面都被加了一个前缀&quot;@&quot;符号,很讨厌,查了查A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQdqnp.html" rel="bookmark" class="title">如何在wap网站里调用手机通讯录？</a>
					<div>
						问题描述 如何在wap网站里调用手机通讯录? 使用html5+jquery mobile开发的wap网站,如何调用手机本地的通讯录呢?有大神做过吗? 解决方案 html5与js是无法读取手机通讯录的, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRN6qGM.html" rel="bookmark" class="title">求教：masterpage中创建的登陆窗口的问题</a>
					<div>
						问题描述 昨天已解决登陆窗口数据库连接和验证的问题.我把登陆窗口设置在masterpage.master母版中,可是母版没有CS代码页,昨天我在母版下新建了一个masterpage.master.cs ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0G94p.html" rel="bookmark" class="title">七万年的人类经验被颠覆？我们何去何从</a>
					<div>
						古语有云:江浙熟,天下足. 在当今的文字指称上,虽然没有&quot;江浙一体&quot;的具体描述,不过从历史上来看,江浙地区曾经长期属于同一行政区管辖.比如清宫戏里面的江浙总督,就是这一区域的最高长 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22oDvb.html" rel="bookmark" class="title">Wi-Fi当前的趋势及对IT和物联网的影响</a>
					<div>
						WiFi当前的趋势 IEEE 802.11系列局域网标准被称作WiFi.最近,WiFi路由器已经由802.11n标准升级到最新的802.11ac标准. 最近数年市场上出现了采用WiFi Direct标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0NR70z.html" rel="bookmark" class="title">document&period;all的用途</a>
					<div>
						  document.all的新用途 现需要做一个抓取网页的程序. 进而有遍历dom的需求,firefox很好办,专门有document.createTreeWalker()函数可用,奇怪的函数,还要 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
